' === Script Information Header ===
' Script Name: GetSubnet.vbs
' Date:        24.02.10
' Author:       
' Description:     IP-  

' === Initialization Block ===
Dim sResult

' === Script Main Logic ===
'    
Set Arguments = Wscript.Arguments
'     
If Wscript.Arguments.Count=2 Then
    '      
    sResult = sResult & GetSubnet(Arguments(0), Arguments(1))
Else
    '    
    Set oLocator = CreateObject("WbemScripting.SWbemLocator")
    Set oWbemServices = oLocator.ConnectServer( , "root\cimv2")
    Set oAdapters = oWbemServices.ExecQuery("Select * FROM Win32_NetworkAdapterConfiguration")
    '       
    For Each oAdapter in oAdapters
        If Not IsNull(oAdapter.IPAddress) Then
            sResult = sResult & "Network adapter: " & vbCrLf _
              & vbTab & oAdapter.Description & vbCrLf
            sResult = sResult & GetSubnet(oAdapter.IPAddress(0), oAdapter.IPSubnet(0)) & vbCrLf
        End If
    Next
    sResult = sResult & "You can also specify an address and Subnet mask as parameters to " _
      & "this script. For example:" & vbCrLf _
      & vbTab & "GetSubnet.vbs 192.168.1.2 255.255.255.255"
End If
'    
WScript.Echo sResult

' === Functions and Procedures ===

'   
Function GetSubnet(Address, Subnet)
    Dim sResult
    If Address = "0.0.0.0" Then
        sResult = sResult & "No network" & vbCrLf
    Else
        sResult = sResult & "IP address:  " & vbCrLf _
          & vbTab & Address & vbCrLf
        sResult = sResult & "Subnet mask: " & vbCrLf _
          & vbTab & Subnet & vbCrLf
        Dim AddressBytes(4)
        Dim SubnetMaskBytes(4)
        i = 0
        Period = 1
        While Period <> Len(address) + 2
            PrevPeriod = Period
            Period = InStr(Period + 1, Address, ".") + 1
            If Period = 1 Then Period = Len(Address) + 2
            AddressByte = Mid(Address, PrevPeriod, Period - PrevPeriod - 1)
            AddressBytes(i) = AddressByte
            i = i + 1
        Wend
        i = 0
        Period = 1
        While Period <> Len (Subnet) + 2
            PrevPeriod = Period
            Period = InStr(Period + 1, Subnet, "." ) + 1
            If Period = 1 Then Period = Len(Subnet) + 2
            SubnetMaskByte = Mid(Subnet, PrevPeriod, Period - PrevPeriod - 1)
            SubnetMaskBytes(i) = SubnetMaskByte
            i = i + 1
        Wend
        Subnet = ""
        For i = 0 to 3
            Subnet = Subnet & (AddressBytes(i) And SubnetMaskBytes(i)) & "."
        Next
        Subnet = Left(Subnet, len(Subnet) - 1)
        sResult = sResult & "Subnet: " & vbCrLf _
          & vbTab & Subnet & vbCrLf
    End If
    GetSubnet = sResult
End Function
